import os
import sys

try:
	import chimera
	from chimera.baseDialog import ModelessDialog
	import VolumeViewer
except:
	print "Chimera not found"
	ModelessDialog=Tkinter.Window

def getVolumeNames():
	files=[]
	names=[]
	files = filter(lambda x:str(x.__class__) =='VolumeViewer.surface.Surface_Model' or str(x.__class__) == "<type '_surface.Surface_Model'>",chimera.openModels.list())
	for volume in files:
		names.append(volume.name)
	return names

def getPDBNames():
	files=[]
	names=[]
	files = filter(lambda x:str(x.__class__) =="chimera.Molecule" or str(x.__class__)=="<type '_chimera.Molecule'>",chimera.openModels.list())
	for mol in files:
		names.append(mol.name)
	return names
	
def getAllNames():
	files=[]
	files=map(lambda x:x.name,chimera.openModels.list())
	return files


def volume_data_set(model):
	d = VolumeViewer.volume_dialog()
	if d == None:
		return None
	for dr in d.data_regions:
		if model in dr.models():
			try:
				output=dr.data_set
			except:
				output=dr
			return output
	return None

def getPath(filename):
	openfiles=chimera.openModels.list()
	for model in openfiles:
		filecheck=str(model.name)
		if  filecheck==str(filename):
			if str(model.__class__)=='VolumeViewer.surface.Surface_Model' or  str(model.__class__)=="<type '_surface.Surface_Model'>":
				path=str(volume_data_set(model).data.path)
			elif str(model.__class__)=="chimera.Molecule" or str(model.__class__)=="<type '_chimera.Molecule'>":
				modelfile=model.openedAs
				path=str(modelfile[0])
			else:
				path=""
			if filecheck==path:
				path=os.path.abspath(model.name)

	return path
	
def getMapInfo(model):
	targetnames=getVolumeNames()
	targetcounter=0
	mapSize=[]
	mapOrigin=[]
	for targetname in targetnames :
		possibletarget=VolumeViewer.volume_dialog()
		try:
			print "old chimera"
			currenttarget=possibletarget.data_sets[targetcounter] 
			if (str(currenttarget.name)).strip()==model.strip():
				data=currenttarget.data
				mapSize=data.size
				mapOrigin=data.xyz_origin
		except:
			print "new chimera"
			currenttarget=possibletarget.data_regions[targetcounter]
			if (str(currenttarget.data.name)).strip()==model.strip():
				data=currenttarget.data
				mapSize=data.size
				mapOrigin=data.origin
		targetcounter=targetcounter+1
	return(mapSize,mapOrigin)
		
def cleanFileName(model):
	name=model.split("<")[0]
	name.strip()
	return name


def cleanTempFiles(filelist):
	for tempfile in filelist:
		cmd0="rm -f %s"%(str(tempfile))
		os.system(cmd0)
	return
